"""indexed_field_size_increase.

Revision ID: a16fa50c27f1
Revises: ad9440a15954
Create Date: 2021-09-20 13:16:31.666334+00:00

"""
import sqlalchemy as sa
import sqlalchemy_utils.types
from alembic import op

# revision identifiers, used by Alembic.
revision = "a16fa50c27f1"
down_revision = "ad9440a15954"
branch_labels = None
depends_on = None


def upgrade() -> None:
    """Upgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    # FLYW-11202 - pre-drop empty temp upgrade tables created and left behind
    # by previous failed upgrade attempts on non-empty sqlite dbs - turns out
    # the uuid casting needed for postgresql is not compatible with sqlite
    try:
        op.drop_table("_alembic_tmp_deid_log")
    except:
        pass
    with op.batch_alter_table("deid_log", schema=None) as batch_op:
        # FLYW-11202 - only do the uuid casting shenanigans on postgres
        if op.get_bind().dialect.name == "postgresql":
            batch_op.alter_column(
                "id",
                existing_type=sa.NUMERIC(precision=16),
                type_=sqlalchemy_utils.types.uuid.UUIDType(),
                existing_nullable=False,
            )
        batch_op.alter_column(
            "AccessionNumber",
            existing_type=sa.VARCHAR(length=16),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientBirthDate",
            existing_type=sa.VARCHAR(length=8),
            type_=sa.String(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientID",
            existing_type=sa.VARCHAR(length=64),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientName",
            existing_type=sa.VARCHAR(length=512),
            type_=sa.String(length=1024),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyInstanceUID",
            existing_type=sa.VARCHAR(length=64),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyID",
            existing_type=sa.VARCHAR(length=16),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDate",
            existing_type=sa.VARCHAR(length=8),
            type_=sa.String(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyTime",
            existing_type=sa.VARCHAR(length=16),
            type_=sa.String(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDateTime",
            existing_type=sa.VARCHAR(length=26),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDescription",
            existing_type=sa.VARCHAR(length=64),
            type_=sa.String(length=1024),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesInstanceUID",
            existing_type=sa.VARCHAR(length=64),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDate",
            existing_type=sa.VARCHAR(length=8),
            type_=sa.String(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesTime",
            existing_type=sa.VARCHAR(length=16),
            type_=sa.String(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDateTime",
            existing_type=sa.VARCHAR(length=26),
            type_=sa.String(length=128),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDescription",
            existing_type=sa.VARCHAR(length=64),
            type_=sa.String(length=1024),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "TimezoneOffsetFromUTC",
            existing_type=sa.VARCHAR(length=16),
            type_=sa.String(length=1024),
            existing_nullable=True,
        )

    # ### end Alembic commands ###


def downgrade() -> None:
    """Downgrade database."""
    # ### commands auto generated by Alembic - please adjust! ###
    with op.batch_alter_table("deid_log", schema=None) as batch_op:
        batch_op.alter_column(
            "TimezoneOffsetFromUTC",
            existing_type=sa.String(length=1024),
            type_=sa.VARCHAR(length=16),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDescription",
            existing_type=sa.String(length=1024),
            type_=sa.VARCHAR(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDateTime",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=26),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesTime",
            existing_type=sa.String(length=64),
            type_=sa.VARCHAR(length=16),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesDate",
            existing_type=sa.String(length=64),
            type_=sa.VARCHAR(length=8),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "SeriesInstanceUID",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDescription",
            existing_type=sa.String(length=1024),
            type_=sa.VARCHAR(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDateTime",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=26),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyTime",
            existing_type=sa.String(length=64),
            type_=sa.VARCHAR(length=16),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyDate",
            existing_type=sa.String(length=64),
            type_=sa.VARCHAR(length=8),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyID",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=16),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "StudyInstanceUID",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientName",
            existing_type=sa.String(length=1024),
            type_=sa.VARCHAR(length=512),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientID",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=64),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "PatientBirthDate",
            existing_type=sa.String(length=64),
            type_=sa.VARCHAR(length=8),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "AccessionNumber",
            existing_type=sa.String(length=128),
            type_=sa.VARCHAR(length=16),
            existing_nullable=True,
        )
        batch_op.alter_column(
            "id",
            existing_type=sqlalchemy_utils.types.uuid.UUIDType(),
            type_=sa.NUMERIC(precision=16),
            existing_nullable=False,
        )

    # ### end Alembic commands ###
